TACHYON
HEX 

\ **************************** VGA FUNCTIONS ********************

: CLRSCN		pixels W@ $6000 ERASE ;

: COLORS	colors W@ W! colors W@ DUP 2+ #382 CMOVE ;

$FF04 COLORS
{  *** this PLOT function is now coded in PASM as part of the kernel                                                            
: PLOT ( x y -- ) 
	6 SHL OVER 3 SHR +  
	SWAP 7 AND MASK SWAP pixels W@ + SET 
	;
}

: HLINE  ( x y length -- ) 
	ROT SWAP ADO I OVER PLOT LOOP DROP 
	;
	
: VLINE  ( x y length -- ) 
	ADO DUP I PLOT LOOP DROP 
	;
{ NOTE: now part of kernel
: ITEM	2* 2* @REG ;

: ITEMS  ( items -- ) 0 DO I ITEM ! LOOP ;
}

: RECT ( x1 y1 xlen ylen -- ) 
	4 ITEMS 
	3 ITEM@ 2 ITEM@ 1 ITEM@ HLINE 
	3 ITEM@ 1 ITEM@ + 2 ITEM@ 0 ITEM@ VLINE 
	3 ITEM@ 2 ITEM@ 0 ITEM@ VLINE 
	3 ITEM@ 2 ITEM@ 0 ITEM@ + 1 ITEM@ HLINE 
	;

: BOXES
	#200 0 DO I I 50 50 RECT 4 +LOOP 
	$C0 $C0 $30 FOR 2DUP $80 $40 RECT SWAP 4 + SWAP 4 - NEXT 2DROP 
;


: SLANTS  180 0 DO 100 0 DO I J + I PLOT LOOP 4 +LOOP ;

\ : RSLANTS  180 0 DO 100 0 DO I 180 J - + 100 I - PLOT LOOP 4  +LOOP ;



: X		8 @REG ;
: Y		#10 @REG ;
: VCR		0 X W! ;
: VLF		#32 Y W+! ;
: HOME		VCR 0 Y W! ;
HOME
: CHAR ( ch -- ) 
       DUP 2/ 7 SHL $8000 + 
       ( ch addr ) 
       20 0 DO DUP @ 3RD 1 AND IF 2/ THEN 
       10 0 DO DUP 1 AND IF X W@ I + Y W@ J + PLOT THEN 2/ 2/ LOOP 
       DROP 4 +  
       LOOP 2DROP #16 X W+! X W@ #500 > IF VCR VLF THEN ;

: CTRL
	DUP $0D = IF VCR DROP EXIT THEN
	DUP $0A = IF VLF DROP EXIT THEN
	DUP $0C = IF HOME CLRSCN DROP EXIT THEN
	DUP $01 = IF HOME DROP EXIT THEN
	DUP $1B = IF DROP R> DROP EXIT THEN
	CHAR
	;
	
: VEMIT		DUP 20 < IF CTRL ELSE CHAR THEN ;
: .VSTR		BEGIN C@++ ?DUP WHILE VEMIT REPEAT DROP ;
: CRECT	( x y xlen ylen -- )
	4 ITEMS 
	3 ITEM@ 1 ITEM@ 2/ - 3 ITEM !
	2 ITEM@ 0 ITEM@ 2/ - 2 ITEM !
	
	3 ITEM@ 2 ITEM@ 1 ITEM@ HLINE 
	3 ITEM@ 1 ITEM@ + 2 ITEM@ 0 ITEM@ VLINE 
	3 ITEM@ 2 ITEM@ 0 ITEM@ VLINE 
	3 ITEM@ 2 ITEM@ 0 ITEM@ + 1 ITEM@ HLINE 
	;

{  Translate this Spin function from the Graphics demo
  repeat y from 1 to 8
    repeat x from 0 to 511
      plot(x, x/y)  
}
: LINES 	1 8 ADO 0 #512 ADO I I J / PLOT LOOP LOOP ;

: SCROLL ( lines -- )
	6 SHL >L 
	pixels W@ $8000 IX - IX CMOVE  
	pixels W@ IX + pixels W@ $6000 L> - CMOVE
	;
: BLANKOFF	colors W@ #352 + $20 ERASE ;
	
: DEMO
	$FF04 COLORS
	CLRSCN HOME
	"       TACHYON GRAPHICS DEMO " .VSTR
	LINES
	1000d ms
	BOXES SLANTS
	1000d ms
	$C000 $1000 ADO I colors W@ #384 CMOVE 100d ms $100 +LOOP
	8 0 DO pixels W@ 6000h I MASK FILL  100d ms LOOP
	#384 0 DO 0 I #512 HLINE 4 +LOOP
	1000d ms
	$FF04 COLORS CLRSCN
	100h 0 DO I CHAR LOOP
	$10000 0 DO I COLORS LOOP
	$FF04 COLORS BLANKOFF
	180 FOR 1 SCROLL NEXT
	180 FOR 2 SCROLL NEXT
	180 FOR 4 SCROLL NEXT
	CLRSCN
	10d 380d ADO 256d 192d I I CRECT 10d +LOOP
	4 FOR $04FF COLORS 300d ms $FF04 COLORS 300d ms NEXT
	CLRSCN BLANKOFF HOME 100h 0 DO I CHAR LOOP
	"       TACHYON GRAPHICS DEMO " .VSTR
	;


END
